/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
////////////////////////////////////////////////////////////////////////////////
//                            GL_X3DRenderer.h                                //
////////////////////////////////////////////////////////////////////////////////

#ifndef X3DGLRENDERER_H
#define X3DGLRENDERER_H

#include "GL_X3DNode.h"
#include "GL_SceneGraphTypes.h"
#include "X3DOnePassProcessor.h"

namespace X3DTK {
namespace GL {

/// X3DGLRenderer module.

class X3DRenderer : public X3DOnePassProcessor
{
public:
  /// Constructor.
  X3DRenderer();
  /// Destructor.
  virtual ~X3DRenderer() = 0;
  
  /// Renders a GLScene.
  virtual void render(SFNode N) const = 0;
  /// Renders a GLScene in a selection mode.
  virtual void select(SFNode N, double x, double y) const = 0;
};

}
}

#endif
