namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TemplateMeshSimplifier<MData, VData, EData, FData, RW>::TemplateMeshSimplifier()
: X3DOnePassProcessor()
{
  stateVariables = Singleton<TemplateMeshSimplifierStateVariables<MData, VData, EData, FData, RW> >::getInstance();
  
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new TemplateMeshSimplifierCoreVisitor<MData, VData, EData, FData, RW>());
}
template<class MData, class VData, class EData, class FData, bool RW>
TemplateMeshSimplifier<MData, VData, EData, FData, RW>::~TemplateMeshSimplifier()
{
  Singleton<TemplateMeshSimplifierStateVariables<MData, VData, EData, FData, RW> >::removeInstance();
  delete graphTraversal;
}
template<class MData, class VData, class EData, class FData, bool RW>
TemplateMesh<MData, VData, EData, FData, RW> *TemplateMeshSimplifier<MData, VData, EData, FData, RW>::build(Scene *S)
{
  stateVariables->init();
  graphTraversal->traverse(S);
  stateVariables->finish(); 
  
  return stateVariables->getMesh();
}

}
}  
