namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TemplateNormalsDrawer<MData, VData, EData, FData, RW>::TemplateNormalsDrawer()
: X3DOnePassProcessor()
{
  stateVariables = Singleton<TemplateNormalsDrawerStateVariables<MData, VData, EData, FData, RW> >::getInstance();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new TemplateNormalsDrawerCoreVisitor<MData, VData, EData, FData, RW>());
}

template<class MData, class VData, class EData, class FData, bool RW>
TemplateNormalsDrawer<MData, VData, EData, FData, RW>::~TemplateNormalsDrawer()
{
  Singleton<TemplateNormalsDrawerStateVariables<MData, VData, EData, FData, RW> >::removeInstance();
  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool RW>
void TemplateNormalsDrawer<MData, VData, EData, FData, RW>::draw(X3DNode *N, float amplitude)
{
  #ifdef TEMPLATE_SPECIALIZATION_SUPPORTED
  if (VData::template find<MESH::VertexPointData>()
   && VData::template find<MESH::VertexNormalData>()
   && FData::template find<MESH::FaceNormalData>())
  #endif 
  { 
    stateVariables->setAmplitude(amplitude);
    stateVariables->init();
    graphTraversal->traverse(N);
    stateVariables->finish();
  }  
}
  
}
}  
