namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TemplateNormalsFlipper<MData, VData, EData, FData, RW>::TemplateNormalsFlipper()
: X3DOnePassProcessor()
{
  stateVariables = Singleton<TemplateNormalsFlipperStateVariables<MData, VData, EData, FData, RW> >::getInstance();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new TemplateNormalsFlipperCoreVisitor<MData, VData, EData, FData, RW>());
}

template<class MData, class VData, class EData, class FData, bool RW>
TemplateNormalsFlipper<MData, VData, EData, FData, RW>::~TemplateNormalsFlipper()
{
  Singleton<TemplateNormalsFlipperStateVariables<MData, VData, EData, FData, RW> >::removeInstance();
  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool RW>
void TemplateNormalsFlipper<MData, VData, EData, FData, RW>::flip(Scene *S)
{
  flip(static_cast<X3DNode *>(S));
  
  S->getProcessHistory().addEntry("MESH::TemplateNormalsFlipper");
}

template<class MData, class VData, class EData, class FData, bool RW>
void TemplateNormalsFlipper<MData, VData, EData, FData, RW>::flip(X3DNode *N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish(); 
}

template<class MData, class VData, class EData, class FData, bool RW>
void TemplateNormalsFlipper<MData, VData, EData, FData, RW>::setSelectedNodes(const MFNode &selectedNodes)
{
  stateVariables->setSelectedNodes(selectedNodes);
}

}
}  
