namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TemplateVerticesDrawer<MData, VData, EData, FData, RW>::TemplateVerticesDrawer()
: X3DOnePassProcessor()
{
  stateVariables = Singleton<TemplateVerticesDrawerStateVariables<MData, VData, EData, FData, RW> >::getInstance();

  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new TemplateVerticesDrawerCoreVisitor<MData, VData, EData, FData, RW>());
}

template<class MData, class VData, class EData, class FData, bool RW>
TemplateVerticesDrawer<MData, VData, EData, FData, RW>::~TemplateVerticesDrawer()
{
  Singleton<TemplateVerticesDrawerStateVariables<MData, VData, EData, FData, RW> >::removeInstance();
  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool RW>
void TemplateVerticesDrawer<MData, VData, EData, FData, RW>::draw(X3DNode *N, bool selection)
{
  stateVariables->setSelectionMode(selection);
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
}

template<class MData, class VData, class EData, class FData, bool RW>
TemplateMesh<MData, VData, EData, FData, RW> *TemplateVerticesDrawer<MData, VData, EData, FData, RW>::getMesh(int i) const 
{
  return stateVariables->getMesh(i);
}

template<class MData, class VData, class EData, class FData, bool RW>
const SFMatrix34f &TemplateVerticesDrawer<MData, VData, EData, FData, RW>::getMatrix(int i) const 
{
  return stateVariables->getMatrix(i);
}

}
}
