namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TemplateX3DBuilder<MData, VData, EData, FData, RW>::TemplateX3DBuilder()
: X3DOnePassProcessor()
{
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new TemplateX3DBuilderCoreVisitor<MData, VData, EData, FData, RW>());

  stateVariables = Singleton<TemplateX3DBuilderStateVariables<MData, VData, EData, FData, RW> >::getInstance();
}

template<class MData, class VData, class EData, class FData, bool RW>
TemplateX3DBuilder<MData, VData, EData, FData, RW>::~TemplateX3DBuilder()
{
  Singleton<TemplateX3DBuilderStateVariables<MData, VData, EData, FData, RW> >::removeInstance();
  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool RW>
X3D::SFNode TemplateX3DBuilder<MData, VData, EData, FData, RW>::build(SFNode N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();

  return stateVariables->getRoot();
}

template<class MData, class VData, class EData, class FData, bool RW>
X3D::Scene *TemplateX3DBuilder<MData, VData, EData, FData, RW>::build(Scene *S)
{
  return static_cast<X3D::Scene *>(build(static_cast<SFNode>(S)));
}

}
}


