/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_RECORDER_H
#define X3DTK_RECORDER_H

#include "BaseRecorder.h"
#include "EnterFunction.h"
#include "WalkOnFunction.h"
#include "LeaveFunction.h"
#include "CreationFunction.h"
#include "NodeFactory.h"
#include "X3DAbstractNode.h"
#include "SFSceneGraph.h"

#include <utility>

namespace X3DTK {

struct StringType
{
  SFString type;
  SFString component;
  SFString sceneGraph;
  SFString encodedName;
};

template<class T>
class Recorder : public BaseRecorder
{
public:
  static std::pair<StringType, EnterFunction *> getEnterFunction(void (*ptrF)(T *));
  static std::pair<StringType, WalkOnFunction *> getWalkOnFunction(bool (*ptrF)(T *, SFAbstractNode));
  static std::pair<StringType, LeaveFunction *> getLeaveFunction(void (*ptrF)(T *));
  static std::pair<StringType, CreationFunction *> getCreationFunction();
};

}

#include "Recorder.inl"

#endif
