namespace X3DTK {

template<class T> 
std::pair<StringType, EnterFunction *> Recorder<T>::getEnterFunction(void (*ptrF)(T *))
{
  BaseRecorder::beginFunctionDefinition();
  
  //finding if an occurence of T
  T *t = new T();

  SFType *type = t->getType();
  std::pair<StringType, EnterFunction *> result;
  result.first.type = type->getName();
  result.first.component = type->getComponentName();
  result.first.sceneGraph = type->getSceneGraphName();  
  result.first.encodedName = type->getEncodedName(); 
  result.second = new EnterFunction(reinterpret_cast<ptrToEnterFunction>(ptrF));
    
  delete t;
  BaseRecorder::endFunctionDefinition();

  return result;
}

template<class T> 
std::pair<StringType, WalkOnFunction *> Recorder<T>::getWalkOnFunction(bool (*ptrF)(T *, SFAbstractNode))
{
  BaseRecorder::beginFunctionDefinition();

  //finding if an occurence of T
  T *t = new T();

  SFType *type = t->getType();
  std::pair<StringType, WalkOnFunction *> result;
  result.first.type = type->getName();
  result.first.component = type->getComponentName();
  result.first.sceneGraph = type->getSceneGraphName();
  result.first.encodedName = type->getEncodedName();
  result.second = new WalkOnFunction(reinterpret_cast<ptrToWalkOnFunction>(ptrF));
       
  delete t;
  BaseRecorder::endFunctionDefinition();

  return result;
}

template<class T> 
std::pair<StringType, LeaveFunction *> Recorder<T>::getLeaveFunction(void (*ptrF)(T *))
{
  BaseRecorder::beginFunctionDefinition();

  //finding if an occurence of T
  T *t = new T();
  
  SFType *type = t->getType();
  std::pair<StringType, LeaveFunction *> result;
  result.first.type = type->getName();
  result.first.component = type->getComponentName();
  result.first.sceneGraph = type->getSceneGraphName();
  result.first.encodedName = type->getEncodedName();  
  result.second = new LeaveFunction(reinterpret_cast<ptrToLeaveFunction>(ptrF));
    
  delete t;
  BaseRecorder::endFunctionDefinition();
  
  return result;
}

template<class T> 
std::pair<StringType, CreationFunction *> Recorder<T>::getCreationFunction()
{
  BaseRecorder::beginFunctionDefinition();

  //finding if an occurence of T
  T *t = new T();
  
  SFType *type = t->getType();
  std::pair<StringType, CreationFunction *> result;
  result.first.type = type->getName();
  result.first.component = type->getComponentName();
  result.first.sceneGraph = type->getSceneGraphName();
  result.first.encodedName = type->getEncodedName();  
  result.second = new CreationFunction(reinterpret_cast<ptrToCreationFunction>(&NodeFactory<T>::create));
    
  delete t;
  BaseRecorder::endFunctionDefinition();
  
  return result;
}


}
