#include "X3D_Price.h"

namespace X3DTK {
namespace X3D {

Price::Price()
: X3DChildNode(), _price(0.0f), _money("euro")
{
  // Defines the tag of the node. This string is the one read in the X3D file.
  defineTypeName("Price");
}

Price::Price(const SFFloat &price, const SFString &money)
: X3DChildNode(), _price(price), _money(money)
{
  // Defines the tag of the node.
  defineTypeName("Price");
}

Price::Price(const Price &P)
: X3DChildNode(P), _price(P._price), _money(P._money)
{
}

SFAbstractNode Price::clone() const
{
  return new Price(*this);
}

void Price::setPrice(const SFFloat &price)
{
  _price = price;
}

void Price::setMoney(const SFString &money)
{
  _money = money;
}

void Price::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("price");
  if (index != -1)
    _price = element->getAttribute(index).toFloat();
  
  index = element->getIndexAttribute("money");
  if (index != -1)
    _money = element->getAttribute(index);  
}

SFString Price::write() const
{
  SFString attr;
  if (_price != 0.0f)    
    attr += " price=\"" + toSFString(_price) + "\"";
  if (_money != "euro")
    attr += " money=\"" + _money + "\"";
      
  return attr;
}

}
}
