#ifndef MYCOORDINATE_H
#define MYCOORDINATE_H

#include <X3DTK/X3D/scenegraph.h>

namespace X3DTK {
namespace X3D {

// Class X3D::MyCoordinate extending the X3D::Coordinate node by adding a weight information.

class MyCoordinate : public Coordinate
{
public:
  MyCoordinate();
  MyCoordinate(const MFVec3f &point,
               const MFFloat &weight);
  
  virtual SFAbstractNode clone() const;
  virtual ~MyCoordinate();
               
  void setWeight(const MFFloat &weight);             
  inline const MFFloat &getWeight() const {return _weight;};
  
  virtual void load(const X3DFileElement *element);
  virtual SFString &write(SFString &output) const;
  
protected: 
  MyCoordinate(const MyCoordinate &C);

private:  
  MFFloat _weight;    
};

}
}

#endif
