namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool RW>
TransformComputer<MData, VData, EData, FData, RW>::TransformComputer()
{
  // Getting the StateVariables
  stateVariables = Singleton<TransformComputerStateVariables<MData, VData, EData, FData, RW> >::getInstance();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new TransformComputerCoreVisitor<MData, VData, EData, FData, RW>());
}

template<class MData, class VData, class EData, class FData, bool RW>
TransformComputer<MData, VData, EData, FData, RW>::~TransformComputer()
{
  Singleton<TransformComputerStateVariables<MData, VData, EData, FData, RW> >::removeInstance();  

  delete graphTraversal;
}

template<class MData, class VData, class EData, class FData, bool RW>
void TransformComputer<MData, VData, EData, FData, RW>::print(SFNode N)
{
  // Testing the presence of MESH::VertexPointData
  #ifdef TEMPLATE_SPECIALIZATION_SUPPORTED
  if (VData::template find<MESH::VertexPointData>())
  #endif
  {
    stateVariables->init();
    graphTraversal->traverse(N);
    stateVariables->finish();
  }  
}

}
}

