#include "MESH_MyStructureComputer.h"
#include "MESH_MyStructureComputerCoreVisitor.h"

namespace X3DTK {
namespace MESH {

MyStructureComputer::MyStructureComputer()
{
  // Getting the StateVariables.
  stateVariables = Singleton<MyStructureComputerStateVariables>::getInstance();
    
  graphTraversal = new DFSGraphTraversal();
  graphTraversal->setComponentVisitor(new MyStructureComputerCoreVisitor());
}

MyStructureComputer::~MyStructureComputer()
{
  Singleton<MyStructureComputerStateVariables>::removeInstance();

  delete graphTraversal;
}

MySimpleMesh *MyStructureComputer::compute(SFNode N)
{
  stateVariables->init();
  graphTraversal->traverse(N);
  stateVariables->finish();
  
  return stateVariables->getMesh();
}

}
}

