#ifndef FCYLINDER_H
#define FCYLINDER_H

#include <X3DTK/X3D/scenegraph.h>

namespace X3DTK {
namespace X3D {

class FCylinder : public Cylinder
{
public:
  // Constructor.
  FCylinder();
  // Constructs a Cylinder from its attributes.
  FCylinder(SFBool bottom, 
            SFFloat radius, 
            SFFloat height, 
            SFBool side, 
            SFBool top,
            SFInt32 section);
            
  // Clones the node.
  virtual SFAbstractNode clone() const;  
  // sets the number of sections.
  void setSection(SFInt32 section);

  // gets the number of sections.
  inline SFInt32 getSection() const {return _section;};
  
  // Loads the attributes from a X3DFileElement e.
  virtual void load(const X3DFileElement *element);
  // Writes the attributes of the node.
  virtual SFString &write(SFString &output) const;

protected:
  // Copy constructor.	   
  FCylinder(const FCylinder &C);

private:
  SFInt32 _section;
};

}
}

#endif
