#include "X3D_Modeler.h"

namespace X3DTK {
namespace X3D {

Modeler::Modeler()
: X3DChildNode(), _name("")
{
  // Defines the tag of the node. This string is the one read in the X3D file.
  defineTypeName("Modeler");
}

Modeler::Modeler(const SFString &name)
: X3DChildNode(), _name(name)
{
  // Defines the tag of the node.
  defineTypeName("Modeler");
}

Modeler::Modeler(const Modeler &P)
: X3DChildNode(P), _name(P._name)
{
}

SFAbstractNode Modeler::clone() const
{
  return new Modeler(*this);
}

void Modeler::setMName(const SFString &name)
{
  _name = name;
}

void Modeler::load(const X3DFileElement *element)
{
  int index;
  index = element->getIndexAttribute("name");
  if (index != -1)
    _name = element->getAttribute(index);  
}

SFString Modeler::write() const
{
  SFString attr;
  if (_name != "")    
    attr += " name=\"" + _name + "\"";
      
  return attr;
}

}
}
